<script setup>
import {defineAsyncComponent, ref} from 'vue'
import {useStudentStore} from "@/stores/student"
import {useGroupStore} from "@/stores/group";

const studentStore = useStudentStore()
const studentFirstName = ref("")
const studentLastName = ref("")
const studentEmail = ref("")
const groupId = ref()
const apiError = ref("")

const groupStore = useGroupStore()

async function createStudent() {
  apiError.value = ""

  try {
    await studentStore.createStudent({
      firstName: studentFirstName.value,
      lastName: studentLastName.value,
      email: studentEmail.value,
      groupId: groupId.value
    })
  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }

  studentFirstName.value = ""
  studentLastName.value = ""
  studentEmail.value = ""
  groupId.value = null
}
</script>

<template>
  <div class="bg-black text-white rounded-2 p-3">
    <form @submit.prevent="createStudent">
      <div class="mb-3 row">
        <label class="col-12 col-md-6">
          <span class="form-label">First Name</span>
          <input type="text" name="firstname" v-model="studentFirstName" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Last Name</span>
          <input type="text" name="lastname" v-model="studentLastName" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Email</span>
          <input type="text" name="email" v-model="studentEmail" class="form-control" required>
        </label>
        <label class="col-12 col-md-6">
          <span class="form-label">Group</span>
          <select class="form-select" name="groupId" v-model="groupId">
            <option v-for="group in groupStore.groups" :value="group.groupId">{{ group.specializations }}
              {{ group.groupNumber }}
            </option>
          </select>
        </label>
      </div>
      <button type="submit" class="btn btn-warning">Add Student</button>
    </form>
  </div>
</template>

<style scoped>
.bg-black {
  width: 1000px;
}
</style>